{
 This is a template for creating plugins for
 Rast's RM2K Plugin Utility for Object Pascal.
 It works for Delphi too. :)
}

// Keep rm2k_ in front of the name.
library rm2k_YourPluginName;

// This function is called when the plugin is
// loaded.
procedure RunPlugin(projectpath: PChar); cdecl;
var
  Project: String;
  CharOn:  Integer;
begin
  // This will change the char-pointer to a
  // usable string.
  SetLength(Project, 0);
  CharOn := 0;
  while projectpath[CharOn] <> #0 do begin
    SetLength(Project, CharOn+1);
    Project[CharOn+1] := projectpath[CharOn];
    Inc(CharOn);
  end;
  
  // Write your code here...!
  
end;

// This function is called when information about
// your plugin is requested.
procedure RunInformationScreen(); cdecl;
begin
  // If you use this, be sure to include the
  // "Dialogs" unit.
  {MessageDlg(
    'Your Plugin Name'#13#10+
    '  -- By Your Name'#13#10#13#10+
    'This is some information about your plugin.'
    mtInformation, [mbOk], 0
  );}
end;

// This function returns the name of your plugin so
// the utility can show it in its plugin list.
function GetRM2KPluginName : PChar; cdecl;
begin
  Result := PChar('Your Plugin Name Here');
end;

// This function returns a short (100 character)
// description of your plugin.
function GetRM2KPluginInfo : PChar; cdecl;
begin
  Result := PChar('Your Plugin Info Here');
end;

// This sets the functions to be exported. You MUST
// have them in this order or it will not load
// correctly! The program doesn't look up the functions
// by name, but rather by which ordinal value, so they
// must stay in this order.
exports
  GetRM2KPluginInfo,
  RunPlugin,
  RunInformationScreen,
  GetRM2KPluginName;
  
begin
  // If your DLL needs to do anything when it's loaded,
  // put that stuff here. This shouldn't run the plugin!
end.